<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Util\Utilities;

class ValidacoesGeraisController {
    
    protected $utilities;

    public function __construct(Utilities $utilities) {
        $this->utilities = $utilities;
    }
    
    /**
	 * Valida no banco se o dados que estao sendo inseridos ja não existem nos campos dos quais estão sendo gravados
	 * 
	 * Retona true se nao existir ou false se já existir 
	 * 
	 * @param string  $string
	 * @param string  $string
     * @param Array  $string
	 */
    public function validarRegistrosDuplicados(Request\Row $request, Response $response){
        $requestRow = $request->getRow();
        $dataSourceName    = $requestRow["DATASOURCE"];
        $pkColumns         = $requestRow["COLUNAS_PK"];
        $validationColumns = $requestRow["COLUNAS_VALIDACAO"];
        $row               = $requestRow["ROW"];
        
        $pieces = explode("/", $dataSourceName);
        $dataSource = $pieces[count($pieces)-1];
        
        $existe = $this->utilities->validateDuplicatedRecords($row, $dataSource, $pkColumns, $validationColumns);
        
        $resultdado = new DataSet("EXISTE", array($existe));
        
        $response->addDataSet($resultdado);
    }
}

?>