<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class SectorFactory {
    protected $connection;
    protected $listParams;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->listParams = array("NRSETOR", "NMSETOR", "IDATIVO");
    }
    
    public function listSector($params) {
        $useParams = false;
        $sqlCode = "SELECT sector.NRSETOR, sector.NMSETOR, sector.IDATIVO, sector.NRORG, sector.DTINCLUSAO,
            sector.CDOPERINCLUSAO, sector.NRORGINCLUSAO, sector.DTULTATU, sector.CDOPERULTATU,
            sector.NRORGULTATU, sector.NRFUNCRESPONSAVEL FROM FCM_SETOR sector";
        foreach($this->listParams as $param) {
            if (array_key_exists($param, $params)) {
                if (!$useParams) {
                    $useParams = true;
                    $sqlCode.= " WHERE ";
                } else {
                    $sqlCode.= " AND ";
                }
                $sqlCode.= "sector." . $param . " = :NRSETOR";
            }
        }
        $std = $this->connection->prepare($sqlCode);
        if ($useParams) {
            $std->execute($params);   
        } else {
            $std->execute();
        }
        return $std->fetchAll();
    }
}

?>