CREATE OR REPLACE
FUNCTION VALOR_SERVICO_MERENDA
(P_CDFILCENTPME IN VARCHAR2,
 P_CDTIPOCARD   IN VARCHAR2,
 P_CDFILIAL     IN VARCHAR2,
 P_CDSERVFILI   IN VARCHAR2,
 P_CDCLIENTE    IN VARCHAR2,
 P_DATAAPURAC   IN DATE)
RETURN FLOAT
IS
   V_VRSERVICO FLOAT;
BEGIN
   SELECT MAX(H.VRSERVICO) INTO V_VRSERVICO
     FROM HISTVRSERVPME H
          /*Pega a maior data de vigncia menor ou igual  data de apurao*/
          INNER JOIN (SELECT CDFILCENTPME, CDTIPOCARD, CDFILIAL,
                             CDSERVFILI, CDCLIENTE, MAX(DTVIGENCIA) DTVIGENCIA
                        FROM HISTVRSERVPME
                       WHERE CDFILCENTPME = P_CDFILCENTPME AND
                             CDTIPOCARD   = P_CDTIPOCARD   AND
                             CDFILIAL     = P_CDFILIAL     AND
                             CDSERVFILI   = P_CDSERVFILI   AND
                             CDCLIENTE    = P_CDCLIENTE    AND
                             DTVIGENCIA <= TRUNC(P_DATAAPURAC)
                       GROUP BY CDFILCENTPME, CDTIPOCARD, CDFILIAL,
                             CDSERVFILI, CDCLIENTE
                     ) MV ON H.CDFILCENTPME = MV.CDFILCENTPME AND
                             H.CDTIPOCARD = MV.CDTIPOCARD AND
                             H.CDFILIAL = MV.CDFILIAL AND
                             H.CDSERVFILI = MV.CDSERVFILI AND
                             H.CDCLIENTE = MV.CDCLIENTE AND
                             H.DTVIGENCIA = MV.DTVIGENCIA
         /*Pega a maior data de atualizao (ltima alterao feito no valor) para a data de vigncia escolhida*/
         INNER JOIN (SELECT CDFILCENTPME, CDTIPOCARD, CDFILIAL,
                            CDSERVFILI, CDCLIENTE, DTVIGENCIA, MAX(DTATUALIZACAO) DTATUALIZACAO
                        FROM HISTVRSERVPME
                       WHERE CDFILCENTPME = P_CDFILCENTPME AND
                             CDTIPOCARD   = P_CDTIPOCARD   AND
                             CDFILIAL     = P_CDFILIAL     AND
                             CDSERVFILI   = P_CDSERVFILI   AND
                             CDCLIENTE    = P_CDCLIENTE    AND
                             DTVIGENCIA <= TRUNC(P_DATAAPURAC)
                       GROUP BY CDFILCENTPME, CDTIPOCARD, CDFILIAL,
                             CDSERVFILI, CDCLIENTE, DTVIGENCIA
                     ) MA ON H.CDFILCENTPME = MA.CDFILCENTPME AND
                             H.CDTIPOCARD = MA.CDTIPOCARD AND
                             H.CDFILIAL = MA.CDFILIAL AND
                             H.CDSERVFILI = MA.CDSERVFILI AND
                             H.CDCLIENTE = MA.CDCLIENTE AND
                             H.DTVIGENCIA = MA.DTVIGENCIA AND
                             H.DTATUALIZACAO = MA.DTATUALIZACAO
    WHERE H.CDFILCENTPME = P_CDFILCENTPME AND
          H.CDTIPOCARD   = P_CDTIPOCARD   AND
          H.CDFILIAL     = P_CDFILIAL     AND
          H.CDSERVFILI   = P_CDSERVFILI   AND
          H.CDCLIENTE    = P_CDCLIENTE    AND          
          H.DTVIGENCIA  <= TRUNC(P_DATAAPURAC);
         
   RETURN(NVL(V_VRSERVICO, 0));
END;