/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CONTOPECTBL                                              */
/* Tabela : CONTOPECTBL                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 06/07/2006 - Fabricio Marcelo                                              */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CONTOPECTBL' and
            type = 'TR'                     and
            u.uid = o.uid                   and
            u.name = USER)
  DROP TRIGGER DTULTATU_CONTOPECTBL
  GO

CREATE TRIGGER DTULTATU_CONTOPECTBL
ON CONTOPECTBL
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CONTOPECTBL', null, 'CDEMPRESA=' + CDEMPRESA + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CONTOPECTBL
      SET DTULTATUCOCB = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(CONTOPECTBL.CDEMPRESA,0)   = ISNULL(INSERTED.CDEMPRESA,0))  AND
            (ISNULL(CONTOPECTBL.DTINICLANC,0)  = ISNULL(INSERTED.DTINICLANC,0)) AND
            (ISNULL(CONTOPECTBL.DTFINALANC,0)  = ISNULL(INSERTED.DTFINALANC,0)) AND
            (ISNULL(CONTOPECTBL.DTINICRELA,0)  = ISNULL(INSERTED.DTINICRELA,0)) AND
            (ISNULL(CONTOPECTBL.DTFINARELA,0)  = ISNULL(INSERTED.DTFINARELA,0)) AND
            (ISNULL(CONTOPECTBL.DTINICCONT,0)  = ISNULL(INSERTED.DTINICCONT,0)) AND
            (ISNULL(CONTOPECTBL.DTFINACONT,0)  = ISNULL(INSERTED.DTFINACONT,0)) AND
            (ISNULL(CONTOPECTBL.IDSALDEMPR,0)  = ISNULL(INSERTED.IDSALDEMPR,0)) AND
            (ISNULL(CONTOPECTBL.IDCONTGERE,0)  = ISNULL(INSERTED.IDCONTGERE,0)) AND
            (ISNULL(CONTOPECTBL.IDCONTCOME,0)  = ISNULL(INSERTED.IDCONTCOME,0)) AND
            (ISNULL(CONTOPECTBL.IDCALCSALD,0)  = ISNULL(INSERTED.IDCALCSALD,0)) AND
            (ISNULL(CONTOPECTBL.DTINICCTBL,0)  = ISNULL(INSERTED.DTINICCTBL,0)) AND
            (ISNULL(CONTOPECTBL.DTFINACCTBL,0) = ISNULL(INSERTED.DTFINACCTBL,0));
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_CONTOPECTBL','4.11.041';
GO

